<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>typescript</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      TypeScript is a language that aims at easing development of large scale
      applications written in JavaScript. TypeScript adds common concepts such
      as classes, modules, interfaces, generics and (optional) static typing to
      JavaScript. It is a superset of JavaScript: all JavaScript code is valid
      TypeScript code so it can be added seamlessly to any project. The
      TypeScript compiler emits JavaScript.
    </p>
    <p>
      This article will focus only on TypeScript extra syntax, as opposed to
      <a href="/docs/javascript">JavaScript</a>.
    </p>
    <p>
      To test TypeScript’s compiler, head to the
      <a href="https://www.typescriptlang.org/play">Playground</a> where you
      will be able to type code, have auto completion and directly see the
      emitted JavaScript.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode ts"
      ><code class="sourceCode typescript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// There are 3 basic types in TypeScript</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">let</span> isDone<span class="op">:</span> <span class="dt">boolean</span> <span class="op">=</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="kw">let</span> lines<span class="op">:</span> <span class="dt">number</span> <span class="op">=</span> <span class="dv">42</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="kw">let</span> name<span class="op">:</span> <span class="dt">string</span> <span class="op">=</span> <span class="st">&quot;Anders&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-5" title="5"></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="co">// But you can omit the type annotation if the variables are derived</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="co">// from explicit literals</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="kw">let</span> isDone <span class="op">=</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="kw">let</span> lines <span class="op">=</span> <span class="dv">42</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-10" title="10"><span class="kw">let</span> name <span class="op">=</span> <span class="st">&quot;Anders&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-11" title="11"></a>
<a class="sourceLine" id="cb1-12" title="12"><span class="co">// When it&#39;s impossible to know, there is the &quot;Any&quot; type</span></a>
<a class="sourceLine" id="cb1-13" title="13"><span class="kw">let</span> notSure<span class="op">:</span> <span class="dt">any</span> <span class="op">=</span> <span class="dv">4</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-14" title="14">notSure <span class="op">=</span> <span class="st">&quot;maybe a string instead&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-15" title="15">notSure <span class="op">=</span> <span class="kw">false</span><span class="op">;</span> <span class="co">// okay, definitely a boolean</span></a>
<a class="sourceLine" id="cb1-16" title="16"></a>
<a class="sourceLine" id="cb1-17" title="17"><span class="co">// Use const keyword for constants</span></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="kw">const</span> numLivesForCat <span class="op">=</span> <span class="dv">9</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-19" title="19">numLivesForCat <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// Error</span></a>
<a class="sourceLine" id="cb1-20" title="20"></a>
<a class="sourceLine" id="cb1-21" title="21"><span class="co">// For collections, there are typed arrays and generic arrays</span></a>
<a class="sourceLine" id="cb1-22" title="22"><span class="kw">let</span> list<span class="op">:</span> <span class="dt">number</span><span class="op">[]</span> <span class="op">=</span> <span class="op">[</span><span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">];</span></a>
<a class="sourceLine" id="cb1-23" title="23"><span class="co">// Alternatively, using the generic array type</span></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="kw">let</span> list<span class="op">:</span> <span class="bu">Array</span><span class="op">&lt;</span><span class="dt">number</span><span class="op">&gt;</span> <span class="op">=</span> <span class="op">[</span><span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">];</span></a>
<a class="sourceLine" id="cb1-25" title="25"></a>
<a class="sourceLine" id="cb1-26" title="26"><span class="co">// For enumerations:</span></a>
<a class="sourceLine" id="cb1-27" title="27"><span class="kw">enum</span> Color <span class="op">{</span> Red<span class="op">,</span> Green<span class="op">,</span> Blue <span class="op">};</span></a>
<a class="sourceLine" id="cb1-28" title="28"><span class="kw">let</span> c<span class="op">:</span> Color <span class="op">=</span> <span class="va">Color</span><span class="op">.</span><span class="at">Green</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-29" title="29"></a>
<a class="sourceLine" id="cb1-30" title="30"><span class="co">// Lastly, &quot;void&quot; is used in the special case of a function returning nothing</span></a>
<a class="sourceLine" id="cb1-31" title="31"><span class="kw">function</span> <span class="fu">bigHorribleAlert</span>()<span class="op">:</span> <span class="dt">void</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-32" title="32">  <span class="fu">alert</span>(<span class="st">&quot;I&#39;m a little annoying box!&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-33" title="33"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-34" title="34"></a>
<a class="sourceLine" id="cb1-35" title="35"><span class="co">// Functions are first class citizens, support the lambda &quot;fat arrow&quot; syntax and</span></a>
<a class="sourceLine" id="cb1-36" title="36"><span class="co">// use type inference</span></a>
<a class="sourceLine" id="cb1-37" title="37"></a>
<a class="sourceLine" id="cb1-38" title="38"><span class="co">// The following are equivalent, the same signature will be inferred by the</span></a>
<a class="sourceLine" id="cb1-39" title="39"><span class="co">// compiler, and same JavaScript will be emitted</span></a>
<a class="sourceLine" id="cb1-40" title="40"><span class="kw">let</span> f1 <span class="op">=</span> <span class="fu">function</span> (i<span class="op">:</span> <span class="dt">number</span>)<span class="op">:</span> <span class="dt">number</span> <span class="op">{</span> <span class="cf">return</span> i <span class="op">*</span> i<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-41" title="41"><span class="co">// Return type inferred</span></a>
<a class="sourceLine" id="cb1-42" title="42"><span class="kw">let</span> f2 <span class="op">=</span> <span class="fu">function</span> (i<span class="op">:</span> <span class="dt">number</span>) <span class="op">{</span> <span class="cf">return</span> i <span class="op">*</span> i<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-43" title="43"><span class="co">// &quot;Fat arrow&quot; syntax</span></a>
<a class="sourceLine" id="cb1-44" title="44"><span class="kw">let</span> f3 <span class="op">=</span> (i<span class="op">:</span> <span class="dt">number</span>)<span class="op">:</span> <span class="dt">number</span> <span class="kw">=&gt;</span> <span class="op">{</span> <span class="cf">return</span> i <span class="op">*</span> i<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-45" title="45"><span class="co">// &quot;Fat arrow&quot; syntax with return type inferred</span></a>
<a class="sourceLine" id="cb1-46" title="46"><span class="kw">let</span> f4 <span class="op">=</span> (i<span class="op">:</span> <span class="dt">number</span>) <span class="kw">=&gt;</span> <span class="op">{</span> <span class="cf">return</span> i <span class="op">*</span> i<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-47" title="47"><span class="co">// &quot;Fat arrow&quot; syntax with return type inferred, braceless means no return</span></a>
<a class="sourceLine" id="cb1-48" title="48"><span class="co">// keyword needed</span></a>
<a class="sourceLine" id="cb1-49" title="49"><span class="kw">let</span> f5 <span class="op">=</span> (i<span class="op">:</span> <span class="dt">number</span>) <span class="kw">=&gt;</span> i <span class="op">*</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb1-50" title="50"></a>
<a class="sourceLine" id="cb1-51" title="51"><span class="co">// Interfaces are structural, anything that has the properties is compliant with</span></a>
<a class="sourceLine" id="cb1-52" title="52"><span class="co">// the interface</span></a>
<a class="sourceLine" id="cb1-53" title="53"><span class="kw">interface</span> Person <span class="op">{</span></a>
<a class="sourceLine" id="cb1-54" title="54">  name<span class="op">:</span> <span class="dt">string</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-55" title="55">  <span class="co">// Optional properties, marked with a &quot;?&quot;</span></a>
<a class="sourceLine" id="cb1-56" title="56">  age<span class="op">?:</span> <span class="dt">number</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-57" title="57">  <span class="co">// And of course functions</span></a>
<a class="sourceLine" id="cb1-58" title="58">  <span class="fu">move</span>()<span class="op">:</span> <span class="dt">void</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-59" title="59"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-60" title="60"></a>
<a class="sourceLine" id="cb1-61" title="61"><span class="co">// Object that implements the &quot;Person&quot; interface</span></a>
<a class="sourceLine" id="cb1-62" title="62"><span class="co">// Can be treated as a Person since it has the name and move properties</span></a>
<a class="sourceLine" id="cb1-63" title="63"><span class="kw">let</span> p<span class="op">:</span> Person <span class="op">=</span> <span class="op">{</span> name<span class="op">:</span> <span class="st">&quot;Bobby&quot;</span><span class="op">,</span> move<span class="op">:</span> () <span class="kw">=&gt;</span> <span class="op">{</span> <span class="op">}</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-64" title="64"><span class="co">// Objects that have the optional property:</span></a>
<a class="sourceLine" id="cb1-65" title="65"><span class="kw">let</span> validPerson<span class="op">:</span> Person <span class="op">=</span> <span class="op">{</span> name<span class="op">:</span> <span class="st">&quot;Bobby&quot;</span><span class="op">,</span> age<span class="op">:</span> <span class="dv">42</span><span class="op">,</span> move<span class="op">:</span> () <span class="kw">=&gt;</span> <span class="op">{</span> <span class="op">}</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-66" title="66"><span class="co">// Is not a person because age is not a number</span></a>
<a class="sourceLine" id="cb1-67" title="67"><span class="kw">let</span> invalidPerson<span class="op">:</span> Person <span class="op">=</span> <span class="op">{</span> name<span class="op">:</span> <span class="st">&quot;Bobby&quot;</span><span class="op">,</span> age<span class="op">:</span> <span class="kw">true</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-68" title="68"></a>
<a class="sourceLine" id="cb1-69" title="69"><span class="co">// Interfaces can also describe a function type</span></a>
<a class="sourceLine" id="cb1-70" title="70"><span class="kw">interface</span> SearchFunc <span class="op">{</span></a>
<a class="sourceLine" id="cb1-71" title="71">  (source<span class="op">:</span> <span class="dt">string</span><span class="op">,</span> subString<span class="op">:</span> <span class="dt">string</span>)<span class="op">:</span> <span class="dt">boolean</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-72" title="72"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-73" title="73"><span class="co">// Only the parameters&#39; types are important, names are not important.</span></a>
<a class="sourceLine" id="cb1-74" title="74"><span class="kw">let</span> mySearch<span class="op">:</span> SearchFunc<span class="op">;</span></a>
<a class="sourceLine" id="cb1-75" title="75">mySearch <span class="op">=</span> <span class="fu">function</span> (src<span class="op">:</span> <span class="dt">string</span><span class="op">,</span> sub<span class="op">:</span> <span class="dt">string</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-76" title="76">  <span class="cf">return</span> <span class="va">src</span><span class="op">.</span><span class="fu">search</span>(sub) <span class="op">!=</span> <span class="dv">-1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-77" title="77"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-78" title="78"></a>
<a class="sourceLine" id="cb1-79" title="79"><span class="co">// Classes - members are public by default</span></a>
<a class="sourceLine" id="cb1-80" title="80"><span class="kw">class</span> <span class="bu">Point</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-81" title="81">  <span class="co">// Properties</span></a>
<a class="sourceLine" id="cb1-82" title="82">  x<span class="op">:</span> <span class="dt">number</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-83" title="83"></a>
<a class="sourceLine" id="cb1-84" title="84">  <span class="co">// Constructor - the public/private keywords in this context will generate</span></a>
<a class="sourceLine" id="cb1-85" title="85">  <span class="co">// the boiler plate code for the property and the initialization in the</span></a>
<a class="sourceLine" id="cb1-86" title="86">  <span class="co">// constructor.</span></a>
<a class="sourceLine" id="cb1-87" title="87">  <span class="co">// In this example, &quot;y&quot; will be defined just like &quot;x&quot; is, but with less code</span></a>
<a class="sourceLine" id="cb1-88" title="88">  <span class="co">// Default values are also supported</span></a>
<a class="sourceLine" id="cb1-89" title="89"></a>
<a class="sourceLine" id="cb1-90" title="90">  <span class="kw">constructor</span>(x<span class="op">:</span> <span class="dt">number</span><span class="op">,</span> <span class="kw">public</span> y<span class="op">:</span> <span class="dt">number</span> <span class="op">=</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-91" title="91">    <span class="va">this</span><span class="op">.</span><span class="at">x</span> <span class="op">=</span> x<span class="op">;</span></a>
<a class="sourceLine" id="cb1-92" title="92">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-93" title="93"></a>
<a class="sourceLine" id="cb1-94" title="94">  <span class="co">// Functions</span></a>
<a class="sourceLine" id="cb1-95" title="95">  <span class="fu">dist</span>()<span class="op">:</span> <span class="dt">number</span> <span class="op">{</span> <span class="cf">return</span> <span class="bu">Math</span><span class="op">.</span><span class="fu">sqrt</span>(<span class="va">this</span><span class="op">.</span><span class="at">x</span> <span class="op">*</span> <span class="va">this</span><span class="op">.</span><span class="at">x</span> <span class="op">+</span> <span class="va">this</span><span class="op">.</span><span class="at">y</span> <span class="op">*</span> <span class="va">this</span><span class="op">.</span><span class="at">y</span>)<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-96" title="96"></a>
<a class="sourceLine" id="cb1-97" title="97">  <span class="co">// Static members</span></a>
<a class="sourceLine" id="cb1-98" title="98">  <span class="kw">static</span> origin <span class="op">=</span> <span class="kw">new</span> <span class="bu">Point</span>(<span class="dv">0</span><span class="op">,</span> <span class="dv">0</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-99" title="99"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-100" title="100"></a>
<a class="sourceLine" id="cb1-101" title="101"><span class="co">// Classes can be explicitly marked as implementing an interface.</span></a>
<a class="sourceLine" id="cb1-102" title="102"><span class="co">// Any missing properties will then cause an error at compile-time.</span></a>
<a class="sourceLine" id="cb1-103" title="103"><span class="kw">class</span> PointPerson <span class="kw">implements</span> Person <span class="op">{</span></a>
<a class="sourceLine" id="cb1-104" title="104">    name<span class="op">:</span> <span class="dt">string</span></a>
<a class="sourceLine" id="cb1-105" title="105">    <span class="fu">move</span>() <span class="op">{}</span></a>
<a class="sourceLine" id="cb1-106" title="106"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-107" title="107"></a>
<a class="sourceLine" id="cb1-108" title="108"><span class="kw">let</span> p1 <span class="op">=</span> <span class="kw">new</span> <span class="bu">Point</span>(<span class="dv">10</span><span class="op">,</span> <span class="dv">20</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-109" title="109"><span class="kw">let</span> p2 <span class="op">=</span> <span class="kw">new</span> <span class="bu">Point</span>(<span class="dv">25</span>)<span class="op">;</span> <span class="co">//y will be 0</span></a>
<a class="sourceLine" id="cb1-110" title="110"></a>
<a class="sourceLine" id="cb1-111" title="111"><span class="co">// Inheritance</span></a>
<a class="sourceLine" id="cb1-112" title="112"><span class="kw">class</span> Point3D <span class="kw">extends</span> <span class="bu">Point</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-113" title="113">  <span class="kw">constructor</span>(x<span class="op">:</span> <span class="dt">number</span><span class="op">,</span> y<span class="op">:</span> <span class="dt">number</span><span class="op">,</span> <span class="kw">public</span> z<span class="op">:</span> <span class="dt">number</span> <span class="op">=</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-114" title="114">    <span class="fu">super</span>(x<span class="op">,</span> y)<span class="op">;</span> <span class="co">// Explicit call to the super class constructor is mandatory</span></a>
<a class="sourceLine" id="cb1-115" title="115">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-116" title="116"></a>
<a class="sourceLine" id="cb1-117" title="117">  <span class="co">// Overwrite</span></a>
<a class="sourceLine" id="cb1-118" title="118">  <span class="fu">dist</span>()<span class="op">:</span> <span class="dt">number</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-119" title="119">    <span class="kw">let</span> d <span class="op">=</span> <span class="va">super</span><span class="op">.</span><span class="fu">dist</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-120" title="120">    <span class="cf">return</span> <span class="bu">Math</span><span class="op">.</span><span class="fu">sqrt</span>(d <span class="op">*</span> d <span class="op">+</span> <span class="va">this</span><span class="op">.</span><span class="at">z</span> <span class="op">*</span> <span class="va">this</span><span class="op">.</span><span class="at">z</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-121" title="121">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-122" title="122"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-123" title="123"></a>
<a class="sourceLine" id="cb1-124" title="124"><span class="co">// Modules, &quot;.&quot; can be used as separator for sub modules</span></a>
<a class="sourceLine" id="cb1-125" title="125"><span class="im">module</span> <span class="dt">Geometry</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-126" title="126">  <span class="im">export</span> <span class="kw">class</span> Square <span class="op">{</span></a>
<a class="sourceLine" id="cb1-127" title="127">    <span class="kw">constructor</span>(<span class="kw">public</span> sideLength<span class="op">:</span> <span class="dt">number</span> <span class="op">=</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-128" title="128">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-129" title="129">    <span class="fu">area</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-130" title="130">      <span class="cf">return</span> <span class="bu">Math</span><span class="op">.</span><span class="fu">pow</span>(<span class="va">this</span><span class="op">.</span><span class="at">sideLength</span><span class="op">,</span> <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-131" title="131">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-132" title="132">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-133" title="133"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-134" title="134"></a>
<a class="sourceLine" id="cb1-135" title="135"><span class="kw">let</span> s1 <span class="op">=</span> <span class="kw">new</span> <span class="va">Geometry</span><span class="op">.</span><span class="fu">Square</span>(<span class="dv">5</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-136" title="136"></a>
<a class="sourceLine" id="cb1-137" title="137"><span class="co">// Local alias for referencing a module</span></a>
<a class="sourceLine" id="cb1-138" title="138"><span class="im">import</span> G <span class="op">=</span> Geometry<span class="op">;</span></a>
<a class="sourceLine" id="cb1-139" title="139"></a>
<a class="sourceLine" id="cb1-140" title="140"><span class="kw">let</span> s2 <span class="op">=</span> <span class="kw">new</span> <span class="va">G</span><span class="op">.</span><span class="fu">Square</span>(<span class="dv">10</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-141" title="141"></a>
<a class="sourceLine" id="cb1-142" title="142"><span class="co">// Generics</span></a>
<a class="sourceLine" id="cb1-143" title="143"><span class="co">// Classes</span></a>
<a class="sourceLine" id="cb1-144" title="144"><span class="kw">class</span> Tuple<span class="op">&lt;</span>T1<span class="op">,</span> T2<span class="op">&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-145" title="145">  <span class="kw">constructor</span>(<span class="kw">public</span> item1<span class="op">:</span> T1<span class="op">,</span> <span class="kw">public</span> item2<span class="op">:</span> T2) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-146" title="146">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-147" title="147"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-148" title="148"></a>
<a class="sourceLine" id="cb1-149" title="149"><span class="co">// Interfaces</span></a>
<a class="sourceLine" id="cb1-150" title="150"><span class="kw">interface</span> Pair<span class="op">&lt;</span>T<span class="op">&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-151" title="151">  item1<span class="op">:</span> T<span class="op">;</span></a>
<a class="sourceLine" id="cb1-152" title="152">  item2<span class="op">:</span> T<span class="op">;</span></a>
<a class="sourceLine" id="cb1-153" title="153"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-154" title="154"></a>
<a class="sourceLine" id="cb1-155" title="155"><span class="co">// And functions</span></a>
<a class="sourceLine" id="cb1-156" title="156"><span class="kw">let</span> pairToTuple <span class="op">=</span> <span class="fu">function</span> <span class="op">&lt;</span>T<span class="op">&gt;</span>(p<span class="op">:</span> Pair<span class="op">&lt;</span>T<span class="op">&gt;</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-157" title="157">  <span class="cf">return</span> <span class="kw">new</span> <span class="fu">Tuple</span>(<span class="va">p</span><span class="op">.</span><span class="at">item1</span><span class="op">,</span> <span class="va">p</span><span class="op">.</span><span class="at">item2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-158" title="158"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-159" title="159"></a>
<a class="sourceLine" id="cb1-160" title="160"><span class="kw">let</span> tuple <span class="op">=</span> <span class="fu">pairToTuple</span>(<span class="op">{</span> item1<span class="op">:</span> <span class="st">&quot;hello&quot;</span><span class="op">,</span> item2<span class="op">:</span> <span class="st">&quot;world&quot;</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-161" title="161"></a>
<a class="sourceLine" id="cb1-162" title="162"><span class="co">// Including references to a definition file:</span></a>
<a class="sourceLine" id="cb1-163" title="163"><span class="co">/// </span><span class="kw">&lt;reference</span><span class="ot"> path=</span><span class="dt">&quot;jquery.d.ts&quot;</span><span class="ot"> </span><span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb1-164" title="164"></a>
<a class="sourceLine" id="cb1-165" title="165"><span class="co">// Template Strings (strings that use backticks)</span></a>
<a class="sourceLine" id="cb1-166" title="166"><span class="co">// String Interpolation with Template Strings</span></a>
<a class="sourceLine" id="cb1-167" title="167"><span class="kw">let</span> name <span class="op">=</span> <span class="st">&#39;Tyrone&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-168" title="168"><span class="kw">let</span> greeting <span class="op">=</span> <span class="vs">`Hi </span><span class="sc">${</span>name<span class="sc">}</span><span class="vs">, how are you?`</span></a>
<a class="sourceLine" id="cb1-169" title="169"><span class="co">// Multiline Strings with Template Strings</span></a>
<a class="sourceLine" id="cb1-170" title="170"><span class="kw">let</span> multiline <span class="op">=</span> <span class="vs">`This is an example</span></a>
<a class="sourceLine" id="cb1-171" title="171"><span class="vs">of a multiline string`</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-172" title="172"></a>
<a class="sourceLine" id="cb1-173" title="173"><span class="co">// READONLY: New Feature in TypeScript 3.1</span></a>
<a class="sourceLine" id="cb1-174" title="174"><span class="kw">interface</span> Person <span class="op">{</span></a>
<a class="sourceLine" id="cb1-175" title="175">  <span class="kw">readonly</span> name<span class="op">:</span> <span class="dt">string</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-176" title="176">  <span class="kw">readonly</span> age<span class="op">:</span> <span class="dt">number</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-177" title="177"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-178" title="178"></a>
<a class="sourceLine" id="cb1-179" title="179"><span class="kw">var</span> p1<span class="op">:</span> Person <span class="op">=</span> <span class="op">{</span> name<span class="op">:</span> <span class="st">&quot;Tyrone&quot;</span><span class="op">,</span> age<span class="op">:</span> <span class="dv">42</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-180" title="180"><span class="va">p1</span><span class="op">.</span><span class="at">age</span> <span class="op">=</span> <span class="dv">25</span><span class="op">;</span> <span class="co">// Error, p1.age is read-only</span></a>
<a class="sourceLine" id="cb1-181" title="181"></a>
<a class="sourceLine" id="cb1-182" title="182"><span class="kw">var</span> p2 <span class="op">=</span> <span class="op">{</span> name<span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span> age<span class="op">:</span> <span class="dv">60</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-183" title="183"><span class="kw">var</span> p3<span class="op">:</span> Person <span class="op">=</span> p2<span class="op">;</span> <span class="co">// Ok, read-only alias for p2</span></a>
<a class="sourceLine" id="cb1-184" title="184"><span class="va">p3</span><span class="op">.</span><span class="at">age</span> <span class="op">=</span> <span class="dv">35</span><span class="op">;</span> <span class="co">// Error, p3.age is read-only</span></a>
<a class="sourceLine" id="cb1-185" title="185"><span class="va">p2</span><span class="op">.</span><span class="at">age</span> <span class="op">=</span> <span class="dv">45</span><span class="op">;</span> <span class="co">// Ok, but also changes p3.age because of aliasing</span></a>
<a class="sourceLine" id="cb1-186" title="186"></a>
<a class="sourceLine" id="cb1-187" title="187"><span class="kw">class</span> Car <span class="op">{</span></a>
<a class="sourceLine" id="cb1-188" title="188">  <span class="kw">readonly</span> make<span class="op">:</span> <span class="dt">string</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-189" title="189">  <span class="kw">readonly</span> model<span class="op">:</span> <span class="dt">string</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-190" title="190">  <span class="kw">readonly</span> year <span class="op">=</span> <span class="dv">2018</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-191" title="191"></a>
<a class="sourceLine" id="cb1-192" title="192">  <span class="kw">constructor</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-193" title="193">    <span class="va">this</span><span class="op">.</span><span class="at">make</span> <span class="op">=</span> <span class="st">&quot;Unknown Make&quot;</span><span class="op">;</span> <span class="co">// Assignment permitted in constructor</span></a>
<a class="sourceLine" id="cb1-194" title="194">    <span class="va">this</span><span class="op">.</span><span class="at">model</span> <span class="op">=</span> <span class="st">&quot;Unknown Model&quot;</span><span class="op">;</span> <span class="co">// Assignment permitted in constructor</span></a>
<a class="sourceLine" id="cb1-195" title="195">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-196" title="196"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-197" title="197"></a>
<a class="sourceLine" id="cb1-198" title="198"><span class="kw">let</span> numbers<span class="op">:</span> <span class="bu">Array</span><span class="op">&lt;</span><span class="dt">number</span><span class="op">&gt;</span> <span class="op">=</span> <span class="op">[</span><span class="dv">0</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">,</span> <span class="dv">4</span><span class="op">];</span></a>
<a class="sourceLine" id="cb1-199" title="199"><span class="kw">let</span> moreNumbers<span class="op">:</span> ReadonlyArray<span class="op">&lt;</span><span class="dt">number</span><span class="op">&gt;</span> <span class="op">=</span> numbers<span class="op">;</span></a>
<a class="sourceLine" id="cb1-200" title="200">moreNumbers<span class="op">[</span><span class="dv">5</span><span class="op">]</span> <span class="op">=</span> <span class="dv">5</span><span class="op">;</span> <span class="co">// Error, elements are read-only</span></a>
<a class="sourceLine" id="cb1-201" title="201"><span class="va">moreNumbers</span><span class="op">.</span><span class="fu">push</span>(<span class="dv">5</span>)<span class="op">;</span> <span class="co">// Error, no push method (because it mutates array)</span></a>
<a class="sourceLine" id="cb1-202" title="202"><span class="va">moreNumbers</span><span class="op">.</span><span class="at">length</span> <span class="op">=</span> <span class="dv">3</span><span class="op">;</span> <span class="co">// Error, length is read-only</span></a>
<a class="sourceLine" id="cb1-203" title="203">numbers <span class="op">=</span> moreNumbers<span class="op">;</span> <span class="co">// Error, mutating methods are missing</span></a>
<a class="sourceLine" id="cb1-204" title="204"></a>
<a class="sourceLine" id="cb1-205" title="205"><span class="co">// Tagged Union Types for modelling state that can be in one of many shapes</span></a>
<a class="sourceLine" id="cb1-206" title="206"><span class="kw">type</span> State <span class="op">=</span> </a>
<a class="sourceLine" id="cb1-207" title="207">  <span class="op">|</span> <span class="op">{</span> type<span class="op">:</span> <span class="st">&quot;loading&quot;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-208" title="208">  <span class="op">|</span> <span class="op">{</span> type<span class="op">:</span> <span class="st">&quot;success&quot;</span><span class="op">,</span> value<span class="op">:</span> <span class="dt">number</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb1-209" title="209">  <span class="op">|</span> <span class="op">{</span> type<span class="op">:</span> <span class="st">&quot;error&quot;</span><span class="op">,</span> message<span class="op">:</span> <span class="dt">string</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-210" title="210"></a>
<a class="sourceLine" id="cb1-211" title="211"><span class="kw">declare</span> <span class="kw">const</span> state<span class="op">:</span> State<span class="op">;</span></a>
<a class="sourceLine" id="cb1-212" title="212"><span class="fu">if</span> (<span class="va">state</span><span class="op">.</span><span class="at">type</span> <span class="op">===</span> <span class="st">&quot;success&quot;</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-213" title="213">  <span class="bu">console</span><span class="op">.</span><span class="fu">log</span>(<span class="va">state</span><span class="op">.</span><span class="at">value</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-214" title="214"><span class="op">}</span> <span class="cf">else</span> <span class="fu">if</span> (<span class="va">state</span><span class="op">.</span><span class="at">type</span> <span class="op">===</span> <span class="st">&quot;error&quot;</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-215" title="215">  <span class="bu">console</span><span class="op">.</span><span class="fu">error</span>(<span class="va">state</span><span class="op">.</span><span class="at">message</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-216" title="216"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-217" title="217"></a>
<a class="sourceLine" id="cb1-218" title="218"><span class="co">// Iterators and Generators</span></a>
<a class="sourceLine" id="cb1-219" title="219"></a>
<a class="sourceLine" id="cb1-220" title="220"><span class="co">// for..of statement</span></a>
<a class="sourceLine" id="cb1-221" title="221"><span class="co">// iterate over the list of values on the object being iterated</span></a>
<a class="sourceLine" id="cb1-222" title="222"><span class="kw">let</span> arrayOfAnyType <span class="op">=</span> <span class="op">[</span><span class="dv">1</span><span class="op">,</span> <span class="st">&quot;string&quot;</span><span class="op">,</span> <span class="kw">false</span><span class="op">];</span></a>
<a class="sourceLine" id="cb1-223" title="223"><span class="fu">for</span> (<span class="kw">const</span> val <span class="kw">of</span> arrayOfAnyType) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-224" title="224">    <span class="bu">console</span><span class="op">.</span><span class="fu">log</span>(val)<span class="op">;</span> <span class="co">// 1, &quot;string&quot;, false</span></a>
<a class="sourceLine" id="cb1-225" title="225"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-226" title="226"></a>
<a class="sourceLine" id="cb1-227" title="227"><span class="kw">let</span> list <span class="op">=</span> <span class="op">[</span><span class="dv">4</span><span class="op">,</span> <span class="dv">5</span><span class="op">,</span> <span class="dv">6</span><span class="op">];</span></a>
<a class="sourceLine" id="cb1-228" title="228"><span class="fu">for</span> (<span class="kw">const</span> i <span class="kw">of</span> list) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-229" title="229">   <span class="bu">console</span><span class="op">.</span><span class="fu">log</span>(i)<span class="op">;</span> <span class="co">// 4, 5, 6</span></a>
<a class="sourceLine" id="cb1-230" title="230"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-231" title="231"></a>
<a class="sourceLine" id="cb1-232" title="232"><span class="co">// for..in statement</span></a>
<a class="sourceLine" id="cb1-233" title="233"><span class="co">// iterate over the list of keys on the object being iterated</span></a>
<a class="sourceLine" id="cb1-234" title="234"><span class="fu">for</span> (<span class="kw">const</span> i <span class="kw">in</span> list) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-235" title="235">   <span class="bu">console</span><span class="op">.</span><span class="fu">log</span>(i)<span class="op">;</span> <span class="co">// 0, 1, 2</span></a>
<a class="sourceLine" id="cb1-236" title="236"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-237" title="237"></a>
<a class="sourceLine" id="cb1-238" title="238"><span class="co">// Type Assertion</span></a>
<a class="sourceLine" id="cb1-239" title="239"></a>
<a class="sourceLine" id="cb1-240" title="240"><span class="kw">let</span> foo <span class="op">=</span> <span class="op">{}</span> <span class="co">// Creating foo as an empty object</span></a>
<a class="sourceLine" id="cb1-241" title="241"><span class="va">foo</span><span class="op">.</span><span class="at">bar</span> <span class="op">=</span> <span class="dv">123</span> <span class="co">// Error: property &#39;bar&#39; does not exist on `{}`</span></a>
<a class="sourceLine" id="cb1-242" title="242"><span class="va">foo</span><span class="op">.</span><span class="at">baz</span> <span class="op">=</span> <span class="st">&#39;hello world&#39;</span> <span class="co">// Error: property &#39;baz&#39; does not exist on `{}`</span></a>
<a class="sourceLine" id="cb1-243" title="243"></a>
<a class="sourceLine" id="cb1-244" title="244"><span class="co">// Because the inferred type of foo is `{}` (an object with 0 properties), you </span></a>
<a class="sourceLine" id="cb1-245" title="245"><span class="co">// are not allowed to add bar and baz to it. However with type assertion,</span></a>
<a class="sourceLine" id="cb1-246" title="246"><span class="co">// the following will pass:</span></a>
<a class="sourceLine" id="cb1-247" title="247"></a>
<a class="sourceLine" id="cb1-248" title="248"><span class="kw">interface</span> Foo <span class="op">{</span> </a>
<a class="sourceLine" id="cb1-249" title="249">  bar<span class="op">:</span> <span class="dt">number</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-250" title="250">  baz<span class="op">:</span> <span class="dt">string</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-251" title="251"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-252" title="252"></a>
<a class="sourceLine" id="cb1-253" title="253"><span class="kw">let</span> foo <span class="op">=</span> <span class="op">{}</span> <span class="im">as</span> Foo<span class="op">;</span> <span class="co">// Type assertion here</span></a>
<a class="sourceLine" id="cb1-254" title="254"><span class="va">foo</span><span class="op">.</span><span class="at">bar</span> <span class="op">=</span> <span class="dv">123</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-255" title="255"><span class="va">foo</span><span class="op">.</span><span class="at">baz</span> <span class="op">=</span> <span class="st">&#39;hello world&#39;</span></a></code></pre>
    </div>
    <h2 id="further-reading">Further Reading</h2>
    <ul>
      <li>[TypeScript Official website] (http://www.typescriptlang.org/)</li>
      <li>
        [TypeScript language specifications]
        (https://github.com/Microsoft/TypeScript/blob/master/doc/spec.md)
      </li>
      <li>
        [Anders Hejlsberg - Introducing TypeScript on Channel 9]
        (http://channel9.msdn.com/posts/Anders-Hejlsberg-Introducing-TypeScript)
      </li>
      <li>[Source Code on GitHub] (https://github.com/Microsoft/TypeScript)</li>
      <li>
        [Definitely Typed - repository for type definitions]
        (http://definitelytyped.org/)
      </li>
    </ul>
  </body>
</html>
